//
//
//
//
#include <qapp.h>
#include <qwidget.h>
#include <qpushbt.h>
#include <qmenubar.h>
#include <stdio.h>
#include <unistd.h>

#define XVM_VER_KXVM "0.0.1"

#include "lib/xvmsupport.h"
#include "dgrid.h"
#include "kxvm.h"

MainWin::MainWin():QWidget(){
	resize(630,440);
	setMinimumSize(630,440);
	setMaximumSize(630,440);
	StartRegGrid();
	StartCommGrid();
	StartMenu();
	StartMessageList();
	messagetimer=new QTimer(this);
	connect(messagetimer,SIGNAL(timeout()),this,SLOT(t100()));
	messagetimer->start(100);
	IB=new DInputBox;
	IB->input("aaa","bbb","ccc");
	show();
};

void 
MainWin::test(){
	QMessageBox::information(this,"KXVM","RegGrid clicked!!");
};

void
MainWin::exit(){
	//destroy(TRUE,TRUE);
	SendMessage(XQ_ST_COM,XQ_TCOM_QUIT);
	close(TRUE);
};

void 
MainWin::StartRegGrid()
{
	int temp;
	RegGrid=new DGrid(this);
	RegGrid->move(0,50);
	RegGrid->resize(175,250);
	RegGrid->Cols(2);
	RegGrid->Rows(100);
	RegGrid->Index(TRUE);
	RegGrid->setWidth(1,105);
	RegGrid->CurCol(0);
	for(temp=1;temp<=RegGrid->Rows();temp++)
	{
		RegGrid->CurRow(temp-1);
		RegGrid->Text(temp);
	};
	RegGrid->CurCol(1);
	RegGrid->CurRow(0);
	//RegGrid->Text("aaa");
	//RegGrid->show();
	UpdateRegs();
};

void 
MainWin::StartCommGrid()
{
	int temp;
	CommGrid=new DGrid(this);
	CommGrid->move(180,50);
	CommGrid->resize(450,250);
	CommGrid->Cols(3);
	CommGrid->Rows(200);
	CommGrid->Index(TRUE);
	CommGrid->setWidth(1,105);
	CommGrid->setWidth(2,275);
	CommGrid->CurCol(0);
	for(temp=1;temp<=CommGrid->Rows();temp++)
	{
		CommGrid->CurRow(temp-1);
		CommGrid->Text(temp);
	};
	CommGrid->CurCol(1);
	CommGrid->CurRow(0);
	UpdateComms();
};

void 
MainWin::StartMenu()
{
	MainMenu=new QMenuBar(this);
	FileMenu=new QPopupMenu;
	FileMenu->insertItem("Exit",this,SLOT(exit()));
	MainMenu->insertItem("File",FileMenu);
	//MainMenu->show();
};

void 
MainWin::StartMessageList()
{
	MessageList=new QListBox(this);
	MessageList->resize(630,90);
	MessageList->move(0,350);
	MessageList->setFocusPolicy(NoFocus);
	MessageList->setAutoScroll(TRUE);
	MessageList->setFont(QFont::QFont("courier",12,QFont::Normal,QFont::Latin5));
};

void
MainWin::ReadSM()
{
	if(ReadMessage(&mbuf)==1 && mbuf.msubtype==XQ_ST_INF)
	{
		MessageList->insertItem(mbuf.mtext);
		/*if(MessageList->count()>20)
		{
			MessageList->removeItem(1);
		};*/
	};
};

void
MainWin::t100()
{
	ReadSM();
};

void
MainWin::UpdateRegs()
{
	int temp;
	SendMessage(XQ_ST_GET_REGLIST,"",1,100);
	RegGrid->CurCol(1);
	for(temp=1;temp<=100;temp++)
	{
		RegGrid->CurRow(temp-1);
		strcpy(mbuf.mtext,"");
		mbuf.msubtype=XQ_ST_NOP;
		WaitMessage(&mbuf);
		if(mbuf.msubtype!=XQ_ST_GET_REGLIST)
		{
			return;
		};
		RegGrid->Text(mbuf.mtext);
	};
};

void 
MainWin::UpdateComms()
{
	int temp;
	SendMessage(XQ_ST_GET_COMMLIST,"",1,200);
	CommGrid->CurCol(1);
	for(temp=1;temp<=200;temp++)
	{
		CommGrid->CurRow(temp-1);
		strcpy(mbuf.mtext,"");
		mbuf.msubtype=XQ_ST_NOP;
		WaitMessage(&mbuf);
		if(mbuf.msubtype!=XQ_ST_GET_COMMLIST)
		{
			return;
		};
		CommGrid->Text(mbuf.mtext);
	};
};

int
main(int argc,char **argv)
{
	QApplication *MainApp=new QApplication(argc,argv);
	MainWin *MyMainWin=new MainWin;
	printf("%s%s%s\n","KXVM Console, version: ",XVM_VER_KXVM," . Copyright(c) 1998 Dmitry Morozhnikov.");
	if(fork()==0)
	{
		execlp("xvmserver","xvmserver",NULL);
	};
	sleep(2);
	if(ConnectQueue()==-1)
	{
		perror("Can`t connect queue ");
		exit(1);
	};
	MainApp->setMainWidget(MyMainWin);
	//MainApp->setStyle(MacStyle);
	MainApp->exec();
	SendMessage(XQ_ST_COM,XQ_TCOM_QUIT);
	delete MainApp;
};

